/*
 * Params:
 * id: folder id (required)
 */
lm.component('lmDialogFolderTokens', {
	templateUrl: 'comp/dialog/lmDialogFolderTokens.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;

		ctrl.items = [];
		
		ctrl.availableRights = ['READ','WRITE'];
		ctrl.selectedRight = 'READ';
		ctrl.availableRanges = [{name: 'DAY',val: 86400000},{name:'WEEK',val: 604800000},{name: 'MONTH',val: 2592000000},{name:'YEAR',val: 31536000000}];
		ctrl.selectedRange = ctrl.availableRanges[1];
		
		ctrl.$onInit = function() {
			if(!ctrl.lmParams.id) {
				console.log("No id param. Closing.");
				ctrl.lmDismiss();
				return;
			}
			
			ctrl.load();			
		};
		
		ctrl.load = function() {
			$http.get(lmBase.url + 'f/folder/' + ctrl.lmParams.id + '/tokens').then(
				function success(resp) {
					ctrl.items = resp.data;
					ctrl.buildLinks();
				},
				serviceLimboMedia.handleHttpErrorNew
			);	
		};
		
		
		ctrl.buildLinks = function() {
			var earl = lmBase.urlFull + '#/link/';
			
			for(x in ctrl.items) {
				var it = ctrl.items[x];
				it.link = earl + it.id + '/' + it.resourceType + '/' + it.resourceId;
			}
		};
		
		ctrl.create = function() {
			var req = {right: ctrl.selectedRight, expires: ctrl.selectedRange.val};
			$http.post(lmBase.url + 'f/folder/' + ctrl.lmParams.id + '/token', req).then(
				function success(resp) {
					ctrl.load();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.remove = function(theitem) {
			$http.delete(lmBase.url + 'f/folder/' + ctrl.lmParams.id + '/token/' + theitem.id).then(
				function success(resp) {
					ctrl.load();
				},
				serviceLimboMedia.handleHttpErrorNew
			);		
		};
		
		ctrl.clipboard = function(theitem) {
			console.log("Copy to clipboard");
		};
		
	}
});
