/*
 * Params:
 * name: current name (required)
 * url: url to update via http post (required)
 */
lm.component('lmDialogRename', {
	templateUrl: 'comp/dialog/lmDialogRename.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;
		
		ctrl.name = '';			/* current name */

		ctrl.$onInit = function() {
			if(!ctrl.lmParams.name) {
				console.log("No name param. Closing.");
				ctrl.lmDismiss();
				return;
			}
			
			if(!ctrl.lmParams.url) {
				console.log("No url param. Closing.");
				ctrl.lmDismiss();
				return;
			}
			
			ctrl.name = ctrl.lmParams.name;
		};
		
		ctrl.ok = function() {
			var req = {name: ctrl.name};
			$http.post(ctrl.lmParams.url,req).then(
				function success(resp) {
					ctrl.lmDone({result: resp.data});
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
	}
});
