/*
 * Params:
 * user: owner
 * url: url to get/post
 */
lm.component('lmDialogShare', {
	templateUrl: 'comp/dialog/lmDialogShare.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia, serviceNotification) {
		var ctrl = this;

		ctrl.shares = [];		/* shares */
		
		ctrl.availableRights = ['READ','WRITE'];
		ctrl.selectedRight = 'READ';
		ctrl.availableUsers = [];
		ctrl.selectedUser = null;
		
		ctrl.$onInit = function() {
			if(!ctrl.lmParams.user) {
				console.log("No user param. Closing.");
				ctrl.lmDismiss();
				return;
			}
			if(!ctrl.lmParams.url) {
				console.log("No url param. Closing.");
				ctrl.lmDismiss();
				return;
			}

			/* load available users */
			$http.get(lmBase.url + 'user/users').then(
				function success(resp) {
					ctrl.availableUsers = resp.data;
					ctrl.selectedUser = ctrl.availableUsers[0];
				},
				serviceLimboMedia.handleHttpErrorNew
			);
			
			/* load shares */
			$http.get(ctrl.lmParams.url).then(
				function success(resp) {
					ctrl.shares = resp.data;
				},
				serviceLimboMedia.handleHttpErrorNew
			);		
		};
		
		ctrl.add = function() {
			if(ctrl.lmParams.user.id == ctrl.selectedUser.id) {
				serviceNotification.error('MSG_SHARE_YOURSELF');
				return;
			}
			
			for(x in ctrl.shares) {
				if(ctrl.selectedUser.id == ctrl.shares[x].user.id) {
					serviceNotification.error('MSG_SHARE_TWICE');
					return;
				}
			}
			
			var uwr = {user: ctrl.selectedUser, right: ctrl.selectedRight};
			ctrl.shares.push(uwr);
		};
		
		ctrl.remove = function(valueUserLabel) {
			for(x in ctrl.shares) {
				if(valueUserLabel == ctrl.shares[x]) {
					ctrl.shares.splice(x,1);
					return;
				}
			}
		};	
		
		ctrl.ok = function() {
			$http.post(ctrl.lmParams.url,ctrl.shares).then(
				function success(resp) {
					ctrl.lmDone();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		
	}
});
