/*
 * Params:
 * item: iot item (required)
 */
lm.component('lmDialogThingAction', {
	templateUrl: 'comp/dialog/lmDialogThingAction.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;

		ctrl.actionTypes = ['','HTTP_GET','HTTP_POST','UDP'];
		ctrl.action = {type: '', url: '', headers: [], host: '', port: 12345, content: ''};
		ctrl.item = null;

		ctrl.$onInit = function() {
			if(!ctrl.lmParams.item) {
				console.log("No item param. Closing.");
				ctrl.lmDismiss();
				return;
			}
			ctrl.item = ctrl.lmParams.item;

			$http.get(lmBase.url + 'iot/item/' + ctrl.item.id + '/action').then(
				function success(resp) {
					if(resp.data.action != null) {
						ctrl.action = resp.data.action;
					}
				},
				serviceLimboMedia.handleHttpErrorNew
			);			
		};
		
		ctrl.ok = function() {
			var req = new Object();
			if(ctrl.action.type != null && ctrl.action.type != '') {
				req.action = ctrl.action;
			}
			$http.post(lmBase.url + 'iot/item/' + ctrl.item.id + '/action',req).then(
				function success(resp) {
					ctrl.lmDone();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};	
	}
});
