/*
 * Params:
 * item: iot item (required)
 */
lm.component('lmDialogThingPull', {
	templateUrl: 'comp/dialog/lmDialogThingPull.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;

		ctrl.actionTypes = ['','HTTP_GET','HTTP_POST'];
		ctrl.item = null;
		ctrl.action = {type: '', url: '', headers: []};
		ctrl.cron = '';

		ctrl.$onInit = function() {
			if(!ctrl.lmParams.item) {
				console.log("No item param. Closing.");
				ctrl.lmDismiss();
				return;
			}
			ctrl.item = ctrl.lmParams.item;
			
			/* load action */
			$http.get(lmBase.url + 'iot/item/' + ctrl.item.id + '/pull').then(
				function success(resp) {
					ctrl.cron = resp.data.cron;
					if(resp.data.action != null) {
						ctrl.action = resp.data.action;
					}
				},
				serviceLimboMedia.handleHttpErrorNew
			);			
		};
		
		ctrl.ok = function() {
			var req = {};
			if(ctrl.cron != '') req.cron = ctrl.cron;
			if(ctrl.action.type != null && ctrl.action.type != '') {
				req.action = ctrl.action;
			}		
			$http.post(lmBase.url + 'iot/item/' + ctrl.item.id + '/pull',req).then(
				function success(resp) {
					ctrl.lmDone();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
	}
});
