/*
 * Params:
 * item: iot item (required)
 */
lm.component('lmDialogThingPush', {
	templateUrl: 'comp/dialog/lmDialogThingPush.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;

		ctrl.item = null;
		ctrl.url = '';
		ctrl.body = '';

		ctrl.$onInit = function() {
			if(!ctrl.lmParams.item) {
				console.log("No item param. Closing.");
				ctrl.lmDismiss();
				return;
			}
			
			ctrl.item = ctrl.lmParams.item;
			
			ctrl.url = lmBase.urlFull + lmBase.url + 'iot/push/' + ctrl.item.uid;
			
			ctrl.body = '{"ts": 1447284448000 {0}}';
			console.log("Type: " + ctrl.item.type);
			
			if('SENSOR_NUMBER' == ctrl.item.type || 'CONTROL_NUMBER' == ctrl.item.type) {
				ctrl.body = ctrl.body.replace('{0}',', "val": 21.5');	
			}
			if('SENSOR_STRING' == ctrl.item.type || 'CONTROL_TEXT' == ctrl.item.type) {
				ctrl.body = ctrl.body.replace('{0}',', "val": "Some value"');	
			}
			if('SENSOR_BOOLEAN' == ctrl.item.type || 'CONTROL_SWITCH' == ctrl.item.type) {
				ctrl.body = ctrl.body.replace('{0}',', "val": true');	
			}
			if('SENSOR_FIRE' == ctrl.item.type || 'CONTROL_FIRE' == ctrl.item.type) {
				ctrl.body = ctrl.body.replace('{0}','');
			}
			if('SENSOR_COORDINATE' == ctrl.item.type) {
				ctrl.body = ctrl.body.replace('{0}',', "x": 11.5754900, "y": 48.1374300');	
			}
			if('CONTROL_PERCENT' == ctrl.item.type) {
				ctrl.body = ctrl.body.replace('{0}',', "val": 0.5');	
			}
			if('CONTROL_SELECT' == ctrl.item.type) {
				ctrl.body = ctrl.body.replace('{0}',', "val": "key1"');	
			}			
		};

	}
});
