lm.component('homeBoxNote', {
	templateUrl: 'comp/homebox/homeBoxNote.' + lmCacheTag + 'html',
	bindings: {
		box: '<'
	},
	controller: function($http, serviceLimboMedia, serviceNotification) {
		var ctrl = this;
		
		ctrl.error = null;
		ctrl.content = null;
		
		ctrl.loadItems = function() {
			$http.get(lmBase.url + 'n/item/' + ctrl.box.noteID).then(
					function success(resp) {
						ctrl.content = resp.data;
					},
					function error(resp) {
						ctrl.error = "Error fetching note. Note has been deleted or access denied.";		
					}
			);
		}
		
		ctrl.itemSave = function() {
			var req = {name: ctrl.content.name, content: ctrl.content.content, labelId: ctrl.content.label.id};
			$http.post(lmBase.url + 'n/item/' + ctrl.content.id,req).then(
				function success(resp) {
					serviceNotification.ok('MSG_SAVED');
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		}
		
		ctrl.$onInit = function() {
			if(ctrl.box.type != 'noteBox') return;
			ctrl.loadItems();
		}

	}
});