lm.component('pageSysCertificate', {
  templateUrl: 'comp/page_sys/pageSysCertificate.' + lmCacheTag + 'html',
  bindings: {
  },
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function($http, serviceLimboMedia, serviceNotification) {
	  var ctrl = this;
	  ctrl.acme = null;
	  ctrl.newdomain = '';
	  
	  ctrl.provider = {};
	  ctrl.providers = null;
	  ctrl.loadProviders = function() {
		  ctrl.providers = null;
		  $http.get(lmBase.url + 'cert/providers').then(
			  function success(resp) {
				  ctrl.providers = resp.data;
				  ctrl.providerSelectActive();
			  },
			  serviceLimboMedia.handleHttpErrorNew
		  );
	  };

	  ctrl.providerSelectActive = function() {
		  for(x in ctrl.providers) {
			  var ok = ctrl.providers[x];
			  if(ok.active) {
				  ctrl.provider = ok;
			  }
		  }
	  };
	  
	  ctrl.providerChanged = function() {
		  var req = {name: ctrl.provider.name};
		  $http.post(lmBase.url + 'cert/provider',req).then(
				  function success(resp) {
						ctrl.loadProviders();
					},
					function error(resp) {
						ctrl.providerSelectActive();
						serviceLimboMedia.handleHttpErrorNew(resp);	
					}
				);
	  };
	  

		ctrl.loadAcme = function() {
			ctrl.acme = null;
			$http.get(lmBase.url + 'acme/acme').then(
				function success(resp) {
					ctrl.acme = resp.data;
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};

		ctrl.acmeRegistrationStart = function() {
			var promise = $http.post(lmBase.url + 'acme/registrationStart').then(
					function success(resp) {
						ctrl.loadAcme();
					},
					serviceLimboMedia.handleHttpErrorNew
				);
			serviceNotification.showWorking(promise);
		};
		
		ctrl.acmeRegistartionAcceptTos = function() {
			var promise = $http.post(lmBase.url + 'acme/registartionAcceptTos').then(
					function success(resp) {
						ctrl.loadAcme();
					},
					serviceLimboMedia.handleHttpErrorNew
				);
			serviceNotification.showWorking(promise);
		};

		ctrl.acmeRegistartionDelete = function() {
			$http.post(lmBase.url + 'acme/registartionDelete').then(
					function success(resp) {
						ctrl.loadAll();
					},
					serviceLimboMedia.handleHttpErrorNew
				);
		};
		
		ctrl.acmeDomainAdd = function() {
			var req = {domain: ctrl.newdomain};
			$http.post(lmBase.url + 'acme/domain/add',req).then(
					function success(resp) {
						ctrl.loadAcme();
					},
					serviceLimboMedia.handleHttpErrorNew
				);
		};
		
		ctrl.acmeDomainRemove = function(domainname) {
			var req = {domain: domainname};
			$http.post(lmBase.url + 'acme/domain/remove',req).then(
					function success(resp) {
						ctrl.loadAcme();
					},
					serviceLimboMedia.handleHttpErrorNew
				);
		};

		ctrl.acmeCertificateRequest = function() {

			var req = {};
			var promise = $http.post(lmBase.url + 'acme/certificateRequest',req).then(
				function success(resp) {
					ctrl.loadAll();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
			
			serviceNotification.showWorking(promise);
		};
		
		ctrl.loadAll = function() {
			ctrl.loadProviders();
			ctrl.loadAcme();
		};
		
		ctrl.loadAll();
  }
});